// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/network_interface_apb_wrapper.hpp"



network_interface_apb_wrapper::network_interface_apb_wrapper( sc_core::sc_module_name
     name_ ) :
    sc_core::sc_module( name_ ),
    pclk("pclk"),
    presetn("presetn"),
    paddr("paddr"),
    psel("psel"),
    penable("penable"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    clk("clk"),
    reset("reset"),
    mode("mode"),
    rx_data_ready("rx_data_ready"),
    rx_data("rx_data"),
    tx_data_ready("tx_data_ready"),
    tx_data("tx_data"),
    tx_data_done("tx_data_done"),
    network_interface_0("network_interface_0")
{
    pready.initialize( false );
    prdata.initialize( 0UL );
    clk = false;
    reset = false;
    mode = false;
    rx_data_ready = false;
    rx_data = 0UL;
    tx_data_ready = false;
    tx_data = 0UL;
    tx_data_done = false;

    network_interface_0.clk( clk );
    network_interface_0.reset( reset );
    network_interface_0.mode( mode );
    network_interface_0.rx_data_ready( rx_data_ready );
    network_interface_0.rx_data( rx_data );
    network_interface_0.tx_data_ready( tx_data_ready );
    network_interface_0.tx_data( tx_data );
    network_interface_0.tx_data_done( tx_data_done );

    SC_METHOD( globact_process_11 );
    sensitive << pclk;

    SC_METHOD( globact_process_12 );
    sensitive << presetn;

    SC_METHOD( globact_process_13 );
    sensitive << pwrite;

    SC_METHOD( globact_process_14 );
    sensitive << rx_data_ready << tx_data_done;

    SC_METHOD( globact_process_15 );
    sensitive << rx_data;

    SC_METHOD( globact_process_16 );
    sensitive << penable;

    SC_METHOD( globact_process_17 );
    sensitive << pwdata;
}

network_interface_apb_wrapper::~network_interface_apb_wrapper()
{}

void network_interface_apb_wrapper::globact_process_11()
{
    clk = pclk.read();
}

void network_interface_apb_wrapper::globact_process_12()
{
    reset = presetn.read();
}

void network_interface_apb_wrapper::globact_process_13()
{
    mode = pwrite.read();
}

void network_interface_apb_wrapper::globact_process_14()
{
    pready = rx_data_ready.read() || tx_data_done.read();
}

void network_interface_apb_wrapper::globact_process_15()
{
    prdata = rx_data.read();
}

void network_interface_apb_wrapper::globact_process_16()
{
    tx_data_ready = penable.read();
}

void network_interface_apb_wrapper::globact_process_17()
{
    tx_data = pwdata.read();
}



